# -*- coding: utf-8 -*- 

import unohelper
import traceback
from threading import Thread
from org.sheetfunction2 import XBackground
from com.sun.star.lang import IllegalArgumentException

class Background(unohelper.Base, XBackground):
    def __init__(self, ctx):
        pass

    # XBackground
    def background(self, celladdress, hexvalue):
        try:
            color = int(hexvalue.strip(" #"), 16)
        except AttributeError:
            try:
                color = int(hexvalue)
            except:
                raise IllegalArgumentException(u'Undefined color value.', self, 1)
        except ValueError:
            raise IllegalArgumentException(u'Undefined color value.', self, 1)
        except:
            traceback.print_exc()
            raise

        if -1 < color < 256**3:
            T = Thread(target=setcolor, args=(celladdress, color))
            T.start()
            return '#{:06X}'.format(color)
        # elif color == -1:
        #     celladdress.CellBackColor = color
        #     return color
        else:
            raise IllegalArgumentException(u'Color value out of range.', self, 1)

def setcolor(cell, color):
    cell.CellBackColor = color

def createInstance(ctx):
    return Background(ctx)


g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(createInstance,"org.sheetfunction2.background.impl", ())
